/* simple types:*/
#define slongint signed long int
#define ulongint unsigned long int

#define DATA_SIZE 1024 //For bmp output
#if FOR_CASIO
  #define XOFF 10      /* coord of the center of the screen         */
  #define YOFF 3       /* counted like this: 0,1,2,3,4,5,6,7,8,9,10 */
  #define XMAX 21      /* screen window casio 21 7                  */
  #define YMAX 7
  #define XBORDER 9    /* when start to center map                  */
  #define YBORDER 2
  #define XMESS 1      /* where to display messages 		    */
  #define YMESS YMAX + 1
#else
  #define XOFF 10      /* big					    */
  #define YOFF 10
  #define XMAX 21
  #define YMAX 21
  #define XBORDER 9    /* where start to center map		    */
  #define YBORDER 9    /* big ends				    */
/*  #define XOFF 10    /* small on PC
  #define YOFF 3
  #define XMAX 21
  #define YMAX 7
  #define XBORDER 9    /* where start to center map
  #define YBORDER 2  /* small ends */
  #define XMESS 1
  #define YMESS YMAX + 1
#endif
/*for both modes:*/
/* if you change this than you must change hand-coded maps in maps.c */
#define MAPX 51      /* Dimension of 1 level 0..MAPX-1 */
#define MAPY 51      /*                      0..MAPY-1 */
#define MINROOMH 5  /* minimal size of room, horizontal 4,4*/
#define MINROOMV 5  /* vertical */
#define RANDROOMH 4  /* random add to size of room horizontal */
#define RANDROOMV 4  /* vertical	*/
#define ROOMDIST 1   /* minimum distance between rooms */
#define ROOMAMOUNT 10 /* number of rooms per level */

#define MONSTER_AMOUNT 10 /* number of monsters per level */
#define SIZE_OF_NAME 11  /* SO SIZE_OF_NAME -1 characters are available */
#define BACKPACK_SIZE 20 /* number of objects player can carry in his backpack */
#define MAX_AMOUNT_OF_ITEMS 255 /* number of objects that can be on the map */

/* modyfiers to attack: */
#define AG_M  10  /* modyfier to Agility */
#define ATK_M 6  /* modyfier to player's Attack */
#define EXA_M 1  /* modyfier to experience all */
#define EXW_M 7  /* modyfier to experience in weapon */
#define WAT_M 8  /* modyfier to Weapons Attack */
#define WWE_M 100/* modyfier to Strength / Weight */
#define WGT_D 300/* divider to TotalWeight */
#define DIV_A 100/* add to divider */

#define DEF_M 6 /* modyfier to player's defence */
#define WDE_M 7 /* weapon defence modyfier */
#define ID_M 10 /* multipier to items like armor helmet etc defence */
#define EXS_M 7 /* modyfier to experience in shields */
#define HAND_WEIGHT 100 /* this is used in attack */
#define HAND_ATK_MOD 10 /* used in attack when fighting barehanded */
#define HAND_DEF_MOD  1 /* */
#define HAND_DAMAGE  10 /* maximum damage caused by player's hand */
#define HAND_DMG_CHAR 25

#define CARRIED_GOLD_AT_START 100
/* add to experience per 1 fight action:*/
  #define EXP_ALL_ADD 5
  #define EXP_BARE_ADD 4
  #define EXP_SWORD_ADD 3
  #define EXP_TWO_HANDED_ADD 2
  #define EXP_CLUBSTAFF_ADD 5
  #define EXP_MISSILE_ADD 2
/* 1 defence: */
  #define EXP_SHIELD_ADD 5

/* character graphics:*/
#if FOR_CASIO
  #define FLOORCHAR '' /* for casio 223 small dot 222 smal x 221 smal [] */
  #define SOLIDCHAR ' '/* rock */
  #define WALLCHAR '#' /* walls */
  #define PLRCHAR '@'  /* player icon */
  #define USTAIRCHAR '' /* stair leading up */
  #define DSTAIRCHAR '' /* stair leading down */
 /* for one stupid case in hand coded maps */
  #define DSTAIRTXT ""
  #define SELECTCHAR '' /* character for selecting in menu */
  #define MORECHAR   '' /* this character informs that more things happeded*/

#else
  #define FLOORCHAR '.'
  #define SOLIDCHAR ' '
  #define WALLCHAR '#'
  #define PLRCHAR '@'
  #define USTAIRCHAR '<' /* stair leading up */
  #define DSTAIRCHAR '>' /* stair leading down */
 /* for one stupid case in hand coded maps */
  #define DSTAIRTXT ">"
  #define SELECTCHAR '>'
  #define MORECHAR   '>'
#endif
/* titleStr for menues, used with puts, so no \n at the end:*/
                     /*1234567890 1234567890*/
#define DROP_ITEM_STR " DROP ITEM:"
#define ITEM_MANIP_STR " ITEM MANIPULATION:"
/* character graphics for both:*/
/*
[    all wearable items
&    all amulets and tools
,    all bracers (this is an exception to the 'image rule' since some
     systems wait for a second key to be pressed after the '~' used for
     bracers and this would make this feature somewhat tiresome to use).
(    all melee weapons
}    all missile weapons
/    all missiles
{    all musical instruments
=    all rings
\    all wands
!    all potions
?    all scrolls
"    all books
%    all food
$    gold
*    all gems
*/
  #define WEAPONCHAR '(' /* swords icon  */
  #define SHIELDCHAR ')' /* shields icon */
  #define ARMORCHAR  '[' /* armors (all wearable items) icon ???*/
  #define POTIONCHAR '!' /* potions icon*/
  #define GOLDCHAR   '$' /* da pretziozen*/

/* KEYS DEFINITION */
/* for both: */
  #define LEFT_KEY   '4'//LEFT_EK
  #define RIGHT_KEY  '6'//RIGHT_EK
  #define UP_KEY     '8'//UP_EK
  #define DOWN_KEY   '2'//DOWN_EK
  #define WAIT_KEY   '5'
  #define UPLE_KEY   '7'
  #define UPRT_KEY   '9'
  #define DNRT_KEY   '3'
  #define DNLE_KEY   '1'

  #define INFO_KEY   F1_EK
  #define REDRAW_KEY F6_EK
  #define PICK_UP_KEY POWER_K
  #define ITEM_KEY   'G'
  #define DRAW_MAP_KEY 'X'

  #define DROP_KEY 'H'
  #define GOUPDN_KEY DOT_K /* You press it at the ladder to go up or down */

/* for casio */
#if FOR_CASIO
  #define EXIT_KEY   ESC_EK
  #define ACCEPT_KEY EXP_EK
/* for PC */
#else
  #define EXIT_KEY   F5_EK
  #define ACCEPT_KEY F3_EK
#endif

/* *** typedefs *** */
typedef unsigned char BMPTabType [DATA_SIZE];

typedef enum {up,dn,le,rt,uple,dnle,uprt,dnrt} dirEType; /* directions movement, fight etc*/
typedef enum {ROGUE,DOG,GIANT} monsterEType;  /*{MONSTER} types of monsters */

typedef enum {NOTHING,/*{ITEM} */
              WEAPON,/* Y */
	      ARMOR,
              CLOAK,
              HELMET,/* Y */
              SHIELD,/* Y */
	      POTION,
              FOOD,
              GOLD,

              MISSILE,
              SPELLBOOK,
              SCROLL,
              WAND
             } ItemKindEType;

typedef enum {SWORD_WPN,
              TWO_HANDED_WPN,
              CLUB_STAFF_WPN,
              MISSILE_WPN
             } WeaponKindEType; /* kinds of weapons, used to determine*/

typedef enum {//TEXT1,/*Special messages: TEXT1 - in arg1 is a string to display*/
              OUCH_WALL,
              DEATH,
	      HIT,
	      MISSED,
	      KILLED,
              NO_PLACE_TO_DROP,
	      DROP_NOTHING,
              DROPPED,
              NOTHING_TO_PICK_UP,
              FULL_BACKPACK,
	      ITEM_PICK_UP,
              REMOVED,
	      NOW_WIELDING,
              NOW_WEARING,
              ALREADY_WIELDING,
              ALREADY_WEARING,
              ENTERING_DUNGEON,
              M_HIT, /* monster hit player */
              M_KILLED /* monster killed player*/
             } messEType; /* messages          */

typedef struct {
  int x;
  int y;
} coordSType;

typedef struct {/* coordinates of a room - for generate_place */
  int x1 [ROOMAMOUNT];
  int y1 [ROOMAMOUNT];
  int x2 [ROOMAMOUNT];
  int y2 [ROOMAMOUNT];
} roomsSType;

typedef char MapGridType [MAPY][MAPX];

typedef struct {
  MapGridType MapGrid;
  roomsSType RoomsCoordS;/* rather SPECIAL coordinates */
  coordSType UCoordS;/* up ladder coord */
  coordSType DCoordS;/* down ladder coord */
} mapSType;  /* contains static map data - walls, floor etc. */

typedef char nameStrType [SIZE_OF_NAME];

typedef struct {/* information about a item, this will be constant*/
  nameStrType ItemName;/* basic info about an item every object has this attrubutes*/
ItemKindEType itemE;
       char ItemSymbol;
        int weight;
        int price;
        int ItemStatusBas; //its base status - how much damage can it resist
  union {/* specific data to specific objects:*/
    struct {/* WEAPON: */
WeaponKindEType WeaponKindE;
      int AtkMod;
      int DefMod;
      int MaxDmg;
      int ChrDmg;/* the value of strength that makes half of max damage*/
    } wpnS;/*weapon union member */
    struct {/* ARMOR: */
      int ArmorDefMod;
    } armS;/*armor union member */
    struct {/* CLOAK: */
      int CloakDefMod;
    } clkS;
    struct {/* HELMET */
      int HelmetDefMod;
    } hlmS;
    struct {/* SHIELD */
      int ShieldDefMod;
    } shldS;
    struct {/* POTION */
      int MinRecover; /* minimal value */
      int RandRecover; /* amount of smthing that will be recovered*/
    } PtnS;     /* so player gets min+rand */
    struct {/* FOOD */
      int FillRate;     /* how good specific food will fill your stomach*/
    } fdS;
//    struct {/* GOLD */
//      //int amount;  not neccesery
//    } gldS;
  } specSU;
} itemSType;

typedef struct {/* list of items on the map - where it is and it's type */
  itemSType *itemSP;
  int ItemStatus;/* item's condition */
  coordSType ItemCoordS;
} ItemsOnLevelSTabType [MAX_AMOUNT_OF_ITEMS];

typedef struct {/* every monster (including player) has those attributes */
  nameStrType name;
  char symbol;
  slongint HpAct;  /* actual character's health */
  itemSType *RtHndSP; /* yep, every monster has right hand wielding da weapon */
  slongint AgAct;  /* actual agility */
  slongint StAct;  /* actual strength */
  slongint AtkAct; /* monsters ability to attack, players base ability to fight*/
  slongint DefAct; /* */
  slongint ExpVal; /* Experience addition for killing this monster */
  int x; /* yep I dont use coordType here */
  int y;
} monsterSType;

typedef monsterSType monstersSTabType [MONSTER_AMOUNT];/* table with info of all monsters in game */

typedef struct {/* information about player's character */
  monsterSType b;/* body - basic info (including name) of every monster */
  slongint HpBas;  /* base character's health */
  slongint AgBas;  /* Agility */
  slongint StBas;  /* Strength */
  slongint AtkBas; /* evaluated complete attack value  */
  slongint DefBas; /* evaluated complete defence value */
  slongint WeightBody;
  slongint WeightTotal;
  slongint ExpBare;
  slongint ExpSword;
  slongint ExpTwoHanded;
  slongint ExpClubStaff;
  slongint ExpMissile;

  slongint ExpShield;
  slongint ExpAll;

  /*carried objects, they are pointers to specifed global data */
  itemSType *headSP;  /* helmet */ int ItemHeadStatus;/* condition of thing in slot */
  itemSType *neckSP;  /* neck   */ int ItemNeckStatus;
  itemSType *bodySP;  /* armor */  int ItemBodyStatus;/* or number of uses left */
  itemSType *cloakSP; /* cloak */  int ItemCloakStatus;
  itemSType *LeHndSP; /* shield */ int ItemLeHndStatus;
/*every monster has it ! weapon */ int ItemRtHndStatus;
  itemSType *LeRngSP; /* le ring*/ int ItemLeRngStatus;
  itemSType *RtRngSP; /* rt ring*/ int ItemRtRngStatus;
  itemSType *backpackSPTab [BACKPACK_SIZE];
  int BackpackStatusTab [BACKPACK_SIZE];
  slongint gold;
  slongint MonstersKilled;/* number of monsters killed by player*/
} playerSType;

/* globals: */
int MessageOnScreenG=0;/* equals 1 when there is a message on the screen */
ulongint NumberOfTurnG=0UL;
ulongint LastMessageTurnG=4294967295UL;//so no more at 0 turn

/* declarations:*/
/* action.c */
void player_birth (playerSType *playerSP);
void menu (int x, int YMin, int  *selP, int amount, char SelectChar);
int item_menu (playerSType *playerSP, char *titleStr,int *ActiveMenuP, int *selectedP, itemSType ***ItemSlotSPP, int *ItemStatusP);
int item_pick_up (playerSType *playerSP, ItemsOnLevelSTabType itemsSTab, MapGridType MapGrid);
int drop_func (playerSType *playerSP, ItemsOnLevelSTabType itemsSTab, MapGridType MapGrid);
int items_manipulation (playerSType *playerSP,ItemsOnLevelSTabType itemsSTab, int *mXP, int *mYP, MapGridType MapGrid, monstersSTabType mnstrsSTab);
int player_action (playerSType *playerSP, int *mXP, int *mYP, monstersSTabType mnstrsSTab, ItemsOnLevelSTabType itemsSTab, mapSType *mapSP);
int npc_action (int MNr, monstersSTabType mnstrsSTab, playerSType *playerSP, MapGridType MapGrid,int *mXP,int *mYP);
int do_move (monsterSType *mnstrSP, dirEType dir, int *mXP, int *mYP, MapGridType MapGrid, monstersSTabType mnstrsSTab);

/* attack.c */
slongint players_attack_act (playerSType *playerSP);
slongint evaluate_damage (slongint strength, itemSType *itemSP);
int attack_p_m (playerSType *attP, monsterSType *defP, int mX,int mY, MapGridType MapGrid);
slongint evaluate_players_defence (playerSType *playerSP);
int attack_m_p (monsterSType *monsterSP, playerSType *playerSP);

/* draw.c */
void clear_message_line (void);
void message (messEType msg,int UpdateMessageTurn , void *arg1P);
void draw_symbol (int pX, int pY, int mX, int mY,char symbol);
void draw_symbol_chk (int pX, int pY, int mX, int mY,char symbol);
void draw_map (int x, int y, MapGridType MapGrid);
void draw_monsters (monstersSTabType mnstrsSTab,int mX,int mY);
void centerY (int pY,int *mYP);
void centerX (int pX,int *mXP);
void draw_info (playerSType *playerSP);
void complete_redraw (int pX,int pY, int *mXP, int *mYP, monstersSTabType mnstrsSTab,MapGridType MapGrid);
void move_draw (int pX, int pY, int mX, int mY, dirEType dir, char symbol,MapGridType MapGrid);

/* dungeon */
void output_room (int x1, int y1, int x2,int y2, char symbol, MapGridType MapGrid);
void clear_dungeon (MapGridType MapGrid);
int cross (int x1,int y1, int x,int x2, int y2, int y);
int room_allowed (int index, roomsSType *RoomsCoordS);
void output_path (int x1,int y1,int x2, int y2, MapGridType MapGrid);
void generate_rooms (mapSType *mapSP);
void output_walls (MapGridType MapGrid);
void generate_dungeon (mapSType *mapSP);
void init_whole_dungeon_level (mapSType *mapSP,
                               ItemsOnLevelSTabType itemsSTab,
                               monstersSTabType mnstrsSTab,
                               playerSType *playerSP, int DungeonLevel);
void generate_place_4item (int *xP, int *yP, mapSType *mapSP);
void generate_place_s (int *xP, int *yP, mapSType *mapSP);

/* graph.c */
void init_graph (void);
void put_pixel (int x, int y);
void output_bmp (BMPTabType BMPTab);
void draw_minimised_map (MapGridType MapGrid);

/* monsters.c */
slongint calculate_items_weight (playerSType *playerSP);
void kill_all_monsters (monstersSTabType mnstrsSTab);
void monster_birth (monsterEType monster_id, int nr, monstersSTabType mnstrsSTab, int pX, int pY, mapSType *mapSP);
void monsters_birth (monstersSTabType mnstrsSTab, int pX, int pY,mapSType *mapSP);
int is_monster (int x,int y, monstersSTabType mnstrsSTab);
dirEType monster_move_to (monsterSType *mnstrP, int x, int y);

/* rpg.c */
void anykey (void);
void quest (playerSType *playerSP, int *mXP, int *mYP, monstersSTabType mnstrsSTab, ItemsOnLevelSTabType itemsSTab, mapSType *mapSP, int *DungeonLevelP);

/* things.c */
void spread_items (int DungeonLevel, mapSType *mapSP, ItemsOnLevelSTabType itemsSTab);
void init_items (ItemsOnLevelSTabType itemsSTab);
int is_item (int x,int y,ItemsOnLevelSTabType itemsSTab);
int free_id_in_backpack (playerSType *playerSP);
int put_item_in_backpack (playerSType *playerSP, itemSType *itemSP, int ItemStatus);
int free_id_in_items_on_map (ItemsOnLevelSTabType itemsSTab);
int place_item_on_map (int coordX, int coordY, itemSType *itemSP, MapGridType MapGrid);
